<?php
/*
Plugin Name: Global Content Blocks
Plugin URI: http://wordpress-plugins.org/global-content-blocks
Description: Create your own shortcodes to add HTML, forms, opt-ins, iframes, Adsense, code snippets, reusable objects, etc, to posts and pages to preserve formatting. Ideal for adding reusable objects to your content or for code that normally gets stripped out or reformatted by the editor
Version: 1.0
Author: Ben Magrill
Author URI: http://wordpress-plugins.org
*/

require_once 'gcb/gcb.class.php';

/*
 * Installs the plugin!
 */
function gcb_intall() {
    global $wpdb;
   $table_name = $wpdb->prefix . "gcb";
     if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
         $sql = "CREATE TABLE " . $table_name . " (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  name varchar(36) NOT NULL,
	  description text NOT NULL,
	  value text NOT NULL,
	  UNIQUE KEY id (id)
	);";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
     add_option("gcb_db_version", "1.0");
     }
}

function gcb_uninstall() {
    if(get_option("gcb_complete_uninstall","no")=="yes") {
    global $wpdb;
      $table_name = $wpdb->prefix . "gcb";
     if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") == $table_name) {
         $sql = "DROP TABLE ".$table_name;
         $wpdb->query($sql);
         delete_option("gcb_db_version");
         delete_option("gcb_complete_uninstall");
     }
    }
}

function gcb_add_submenu() {
    $gcb_page = add_options_page( "Global Content Blocks", "Global Content Blocks", "publish_pages", "global-content-blocks", "gcb_submenu");
    add_action( "admin_print_scripts-$gcb_page", 'gcb_loadjs_admin_head' );
}

function gcb_loadjs_admin_head() {
    wp_enqueue_script('gcb_uni_script', get_option('siteurl').'/wp-content/plugins/global-content-blocks/resources/extra/extra.js');
}

function gcb_submenu() {
       global $wpdb;
        $msg = "";
    if(isset($_POST["gcb_delete"])) {
        if(isset($_POST["gcb_del"]) && is_array($_POST["gcb_del"])) {
            foreach($_POST["gcb_del"] as $bd) {
                 $wpdb->query("delete from ".$wpdb->prefix."gcb where id=".intval($bd)." limit 1");
            }
            $msg = "Deleted!";
        }
    }

    if(isset($_POST["gcb_unin"])) {
        if(isset($_POST["ch_unin"])) {
           update_option("gcb_complete_uninstall","yes");
        }
        else
        {
            update_option("gcb_complete_uninstall","no");
        }
    }

    if(isset($_POST["gcb_save"])) {
        $name = $_POST["gcb_name"];
        $description = htmlspecialchars($_POST['gcb_description']);
        $value = htmlspecialchars($_POST['gcb_value']);

        if(strlen($name) && strlen($value)) {
        if(isset($_POST["update_it"])) {
           $wpdb->query("update ".$wpdb->prefix."gcb set name='".$name."',description='".$description."',value='".$value."' where id=".intval($_POST["update_it"]." limit 1"));
           $msg = "Entry updated!";
        }
        else
        {
            $wpdb->query("insert into ".$wpdb->prefix . "gcb (name,description,value) VALUES ('".$name."','".$description."','".$value."')");
            $msg = "Entry inserted!";
        }
        }
        else
        {
             $msg = "Name and Content are mandatory!";
        }
    }
    
    echo gcb::main_page($msg);
}


function gcb_shortcode_replacer($atts, $content=null, $code="") {
    $a = shortcode_atts( array('id' => 0), $atts );
    if($a["id"]==0) return "";
     global $wpdb;
     //does this one exist ?
     $ex = $wpdb->get_var("SELECT COUNT(*) from `".$wpdb->prefix."gcb` WHERE `id` = ".$a["id"].";");
     if($ex==1) {
    $record = $wpdb->get_row("SELECT value FROM `".$wpdb->prefix."gcb` WHERE `id` = ".$a["id"].";");
     return htmlspecialchars_decode($record->value);
     }
     else
     {   return "";    }
}



/**
 * Hooks
 */
register_activation_hook(__FILE__,'gcb_intall');
register_deactivation_hook(__FILE__,'gcb_uninstall');
add_action('admin_menu', 'gcb_add_submenu');
add_shortcode('contentblock', 'gcb_shortcode_replacer');



        // Load the custom TinyMCE plugin
function gcb_mce_external_plugins( $plugins ) {
		$plugin_array['gcbplugin'] =get_option('siteurl')."/wp-content/plugins/global-content-blocks/resources/tinymce/editor_plugin.js";
                return $plugin_array;
	}

function gcb_mce_buttons( $buttons ) {
                array_push( $buttons,"|","gcb");
		return $buttons;
}

function gcb_addbuttons() {
// Don't bother doing this stuff if the current user lacks permissions
if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
            return;

// Register editor button hooks
if ( get_user_option('rich_editing') == 'true') {     
add_filter( 'mce_external_plugins','gcb_mce_external_plugins');
add_filter( 'mce_buttons', 'gcb_mce_buttons');
     }
}

function gcb_my_refresh_mce($ver) {
  $ver += 3;
  return $ver;
}
// init process for button control
add_action('init', 'gcb_addbuttons');
add_filter( 'tiny_mce_version', 'gcb_my_refresh_mce');
